package body Stack
--# own State is Pointer, Vector; -- rappresentazione
-- # Raffinamento:
-- # R_empty: State = empty_f <-> Pointer = 0 and
-- #             ( for all I in IntStackT => (Vector(I) = 0) ) ;
-- # R_clear-1:
is

   subtype PointerT is Natural range Natural'First .. MaxSize;

   Pointer : PointerT;

   type IntVectorT is array (Integer range <>) of Integer;
   subtype StackRange is Positive range 1 .. MaxSize;
   subtype IntStackT is IntVectorT (StackRange);

   Vector : IntStackT;

   EmptyVector : constant IntStackT := IntStackT'(StackRange => 0);

   -----------
   -- Empty --
   -----------

   function Empty return Boolean
   --# global Pointer;
   --# return ( Pointer = 0 );
   is
   begin
      return Pointer = 0;
   end Empty;

   -----------
   -- Clear --
   -----------

   --# function zeros(V: IntStackT) return Boolean;
   --  Def zeros(V) <->  ( for all I in IntStackT => (V(I) = 0) );
   --  R_zeros : zeros(EmptyVector) <-> true;

   procedure Clear
   --# global out Pointer, Vector;
   --# derives Pointer, Vector from ;
   --# post Pointer = 0;
   is
   begin
      Pointer := 0;
      Vector  := EmptyVector;
   end Clear;

   ---------
   -- Pop --
   ---------

   procedure Pop (X : out Integer)
   --# global in out Pointer; in Vector; -- Vector non  modificato!
   --# derives Pointer from *            -- ma State s.
   --# &             X from Pointer, Vector;
   --# pre  Pointer > 0 ;
   --# post Pointer = Pointer~ - 1 and X = Vector(Pointer~) ;
   -- #      and ( for all I in StackRange range StackRange'First .. Pointer - 1
   -- #            => ( Vector(I) = Vector(I) )) ;
   -- non serve, per via del modo di Vector
   is
   begin
      X := Vector(Pointer);
      Pointer := Pointer - 1;
   end Pop;

   ----------
   -- Push --
   ----------

   procedure Push (Y : in Integer)
   --# global in out Pointer, Vector;
   --# derives Pointer from *
   --# &        Vector from *, Pointer, Y;
   --# pre  Pointer < StackRange'Last;
   --# post Pointer = Pointer~ + 1 and Vector(Pointer) = Y and
   --#      ( for all I in StackRange range StackRange'First .. Pointer~
   --#            => ( Vector(I) = Vector~(I) )) ;

   is
   begin
      Pointer := Pointer + 1;
      Vector(Pointer) := Y;
   end Push;

begin
      Pointer := 0;
      Vector  := EmptyVector;
end Stack;
