package Stack
   --# own State : StackAT;
   --# initializes State;
is
   --# type StackAT is abstract;
   --# function empty_a(S: StackAT) return Boolean;
   --# function push_a(X : Integer; S : StackAT) return StackAT;
   --# function pop_a(S : StackAT) return StackAT;
   --# function top_a(S : StackAT) return Integer;
   --# function size_a(S : StackAT) return Natural;

   MaxSize : constant Natural := 100;

   function Empty return Boolean;
   --# global State;
   --# return empty_a(State);

   procedure Clear;
   --# global out State;
   --# derives State from ;
   --# post empty_a(State) ;

   procedure Pop (X : out Integer);
   --# global in out State;
   --# derives State from *
   --# &       X     from State;
   --# pre  not empty_a(State);
   ----# post X = top_a(State~) and
   ----#      State = pop_a(State~) ;
   --# post State~ = push_a(X, State) ;

   procedure Push (Y : in Integer);
   --# global in out State;
   --# derives State from *,Y;
   --# pre  size_a(State) < MaxSize ;
   --# post State = push_a(Y, State~);
end Stack;
